<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>morphorobotx: parms.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">morphorobotx
   </div>
   <div id="projectbrief">morphorobotxsharedlibrary</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1.2 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(9)"><span class="SelectionMark">&#160;</span>Macros</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">parms.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="parms_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef __PARMS_H__</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor"></span><span class="preprocessor">#define __PARMS_H__</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &lt;sstream&gt;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;set&gt;</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;list&gt;</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;QString&gt;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &lt;iterator&gt;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;QTextStream&gt;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &lt;QStringList&gt;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &lt;QHash&gt;</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;QTextStream&amp; <a class="code" href="parms_8cpp.html#ad60ff07217a30822cd9262e800eb4917">operator&gt;&gt;</a>(QTextStream&amp; ss, <span class="keywordtype">bool</span> b);</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;QTextStream&amp; <a class="code" href="parms_8cpp.html#a4a21a193b34d5509ebb552f74ca489b1">operator&lt;&lt;</a>(QTextStream&amp; ss, <span class="keywordtype">bool</span> b);</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div>
<div class="line"><a name="l00099"></a><span class="lineno"><a class="code" href="classParms.html">   99</a></span>&#160;<span class="keyword">class </span><a class="code" href="classParms.html" title="A utility class to parse L-Studio like parameter files.">Parms</a></div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;{</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00102"></a><span class="lineno"><a class="code" href="classParms.html#aa44d348824ac5264b1e5c256ec8187e0">  102</a></span>&#160;    <span class="keyword">static</span> QTextStream <a class="code" href="classParms.html#aa44d348824ac5264b1e5c256ec8187e0">err</a>;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div>
<div class="line"><a name="l00104"></a><span class="lineno"><a class="code" href="classParms.html#a80a81d2533d9b325b34ebf603acb6f50">  104</a></span>&#160;    <span class="keyword">enum</span> <a class="code" href="classParms.html#a80a81d2533d9b325b34ebf603acb6f50">VerbosityLevels</a></div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    {</div>
<div class="line"><a name="l00106"></a><span class="lineno"><a class="code" href="classParms.html#a80a81d2533d9b325b34ebf603acb6f50acf60f8088185516998374ea64579e48d">  106</a></span>&#160;        <a class="code" href="classParms.html#a80a81d2533d9b325b34ebf603acb6f50acf60f8088185516998374ea64579e48d">NO_OUTPUT</a> = 0,</div>
<div class="line"><a name="l00107"></a><span class="lineno"><a class="code" href="classParms.html#a80a81d2533d9b325b34ebf603acb6f50a6f61b4d8674b98fe448bcd5e76214187">  107</a></span>&#160;        <a class="code" href="classParms.html#a80a81d2533d9b325b34ebf603acb6f50a6f61b4d8674b98fe448bcd5e76214187">ERRORS_ONLY</a>,</div>
<div class="line"><a name="l00108"></a><span class="lineno"><a class="code" href="classParms.html#a80a81d2533d9b325b34ebf603acb6f50a88d0cbb9fd12f758d1ea05c3d2a2f770">  108</a></span>&#160;        <a class="code" href="classParms.html#a80a81d2533d9b325b34ebf603acb6f50a88d0cbb9fd12f758d1ea05c3d2a2f770">ERRORS_WARNINGS</a>,</div>
<div class="line"><a name="l00109"></a><span class="lineno"><a class="code" href="classParms.html#a80a81d2533d9b325b34ebf603acb6f50a9d1b33b8d137c3069a6ce0af96a771c6">  109</a></span>&#160;        <a class="code" href="classParms.html#a80a81d2533d9b325b34ebf603acb6f50a9d1b33b8d137c3069a6ce0af96a771c6">USER_INFORMATION</a>,</div>
<div class="line"><a name="l00110"></a><span class="lineno"><a class="code" href="classParms.html#a80a81d2533d9b325b34ebf603acb6f50a7b04eefc246a0dd00cc201737d6cadb6">  110</a></span>&#160;        <a class="code" href="classParms.html#a80a81d2533d9b325b34ebf603acb6f50a7b04eefc246a0dd00cc201737d6cadb6">DEBUG_INFORMATION</a></div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    };</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    <span class="keyword">explicit</span> <a class="code" href="classParms.html#a5b77c4c61f2d8c9535b2fa00870ec7ad">Parms</a>(<span class="keywordtype">int</span> <a class="code" href="classParms.html#a890d2d6193134e01eb3bc76e61346984">verboseLevel</a> = 1);</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    <a class="code" href="classParms.html#a5b77c4c61f2d8c9535b2fa00870ec7ad">Parms</a>(QString parmFile, <span class="keywordtype">int</span> <a class="code" href="classParms.html#a890d2d6193134e01eb3bc76e61346984">verboseLevel</a> = 1);</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    <a class="code" href="classParms.html#ad7c9af575c1d876981440a1f8ff344c3">~Parms</a>();</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#aa8d03678c72d85a7cebd3bd33dfe0c63">read</a>(QString parmFile);</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a256c20317703bd47a21489d72d358ec3">write</a>(QString parmFile) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;</div>
<div class="line"><a name="l00140"></a><span class="lineno"><a class="code" href="classParms.html#a890d2d6193134e01eb3bc76e61346984">  140</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classParms.html#a890d2d6193134e01eb3bc76e61346984">verboseLevel</a>( <span class="keywordtype">int</span> vl ) { <a class="code" href="classParms.html#a304288b4be84e292ebe1dad50aabe59f">VerboseLevel</a> = ( vl &lt; 0 ) ? 0 : vl; }</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;</div>
<div class="line"><a name="l00145"></a><span class="lineno"><a class="code" href="classParms.html#ab0d9acbb8f7ac20ef7719b05dd53818b">  145</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#ab0d9acbb8f7ac20ef7719b05dd53818b">isLoaded</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classParms.html#a8ca128b8c8e4cc8655486397ca04080b">loaded</a>; }</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a3a292306fef32acb636751b874a62950">operator()</a>( QString section, QString key, T&amp; value ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    <span class="keywordtype">bool</span> <span class="keyword">set</span>(QString section, QString key, <span class="keyword">const</span> T&amp; value, <span class="keyword">const</span> QStringList&amp; comment = QStringList());</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    <span class="keywordtype">bool</span> <span class="keyword">set</span>(QString section, QString key, <span class="keyword">const</span> <span class="keywordtype">bool</span>&amp; value, <span class="keyword">const</span> QStringList&amp; comment = QStringList());</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    <span class="keywordtype">bool</span> <span class="keyword">set</span>(QString section, QString key, <span class="keyword">const</span> <span class="keywordtype">int</span>&amp; value, <span class="keyword">const</span> QStringList&amp; comment = QStringList());</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;    <span class="keywordtype">bool</span> <span class="keyword">set</span>(QString section, QString key, <span class="keyword">const</span> <span class="keywordtype">float</span>&amp; value, <span class="keyword">const</span> QStringList&amp; comment = QStringList());</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    <span class="keywordtype">bool</span> <span class="keyword">set</span>(QString section, QString key, <span class="keyword">const</span> <span class="keywordtype">double</span>&amp; value, <span class="keyword">const</span> QStringList&amp; comment = QStringList());</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;    <span class="keywordtype">bool</span> <span class="keyword">set</span>(QString section, QString key, <span class="keyword">const</span> std::string&amp; value, <span class="keyword">const</span> QStringList&amp; comment = QStringList());</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    <span class="keywordtype">bool</span> <span class="keyword">set</span>(QString section, QString key, QString value, <span class="keyword">const</span> QStringList&amp; comment = QStringList());</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#aeee98ee77c359e3b6efd47e4168d4772" title="setComment set the comment on a section">setComment</a>(QString section, <span class="keyword">const</span> QStringList&amp; comment);</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#aeee98ee77c359e3b6efd47e4168d4772" title="setComment set the comment on a section">setComment</a>(QString section, <span class="keyword">const</span> QString&amp; comment);</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a45d70c2a3327c8f241ab38364d3d00b6" title="setComments set the comments for a set of existing [section]key">setComments</a>(QString section, QString key, <span class="keyword">const</span> QList&lt;QStringList&gt;&amp; comments);</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#aeee98ee77c359e3b6efd47e4168d4772" title="setComment set the comment on a section">setComment</a>(QString section, QString key, <span class="keyword">const</span> QStringList&amp; comment);</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#aeee98ee77c359e3b6efd47e4168d4772" title="setComment set the comment on a section">setComment</a>(QString section, QString key, <span class="keyword">const</span> QString&amp; comment);</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a8c04c71e01c3145028c23c480a842b19">add</a>(QString section, QString key, <span class="keyword">const</span> T&amp; value, <span class="keyword">const</span> QStringList&amp; comment = QStringList());</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a8c04c71e01c3145028c23c480a842b19">add</a>(QString section, QString key, <span class="keyword">const</span> <span class="keywordtype">bool</span>&amp; value, <span class="keyword">const</span> QStringList&amp; comment = QStringList());</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a8c04c71e01c3145028c23c480a842b19">add</a>(QString section, QString key, <span class="keyword">const</span> <span class="keywordtype">int</span>&amp; value, <span class="keyword">const</span> QStringList&amp; comment = QStringList());</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a8c04c71e01c3145028c23c480a842b19">add</a>(QString section, QString key, <span class="keyword">const</span> <span class="keywordtype">float</span>&amp; value, <span class="keyword">const</span> QStringList&amp; comment = QStringList());</div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a8c04c71e01c3145028c23c480a842b19">add</a>(QString section, QString key, <span class="keyword">const</span> <span class="keywordtype">double</span>&amp; value, <span class="keyword">const</span> QStringList&amp; comment = QStringList());</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a8c04c71e01c3145028c23c480a842b19">add</a>(QString section, QString key, <span class="keyword">const</span> std::string&amp; value, <span class="keyword">const</span> QStringList&amp; comment = QStringList());</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a8c04c71e01c3145028c23c480a842b19">add</a>(QString section, QString key, QString value, <span class="keyword">const</span> QStringList&amp; comment = QStringList());</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;</div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a3a292306fef32acb636751b874a62950">operator()</a>( QString section, QString key, <span class="keywordtype">bool</span>&amp; value ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a3a292306fef32acb636751b874a62950">operator()</a>( QString section, QString key, <span class="keywordtype">int</span>&amp; value ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a3a292306fef32acb636751b874a62950">operator()</a>( QString section, QString key, <span class="keywordtype">float</span>&amp; value ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a3a292306fef32acb636751b874a62950">operator()</a>( QString section, QString key, <span class="keywordtype">double</span>&amp; value ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a3a292306fef32acb636751b874a62950">operator()</a>( QString section, QString key, std::string&amp; value ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;</div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a3a292306fef32acb636751b874a62950">operator()</a>( QString section, QString key, QString&amp; value ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;</div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a3a292306fef32acb636751b874a62950">operator()</a>( QString section, QString key, T&amp; value, <span class="keyword">const</span> T&amp; def ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;</div>
<div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Container&gt;</div>
<div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#aa6041b7843059839d6dd2e7098ee40b6">all</a>( QString section, QString key, Container&amp; value ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;</div>
<div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#aa6041b7843059839d6dd2e7098ee40b6">all</a>( QString section, QString key, <a class="code" href="classstd_1_1vector.html">std::vector&lt;bool&gt;</a>&amp; value ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#aa6041b7843059839d6dd2e7098ee40b6">all</a>( QString section, QString key, <a class="code" href="classstd_1_1vector.html">std::vector&lt;int&gt;</a>&amp; value ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#aa6041b7843059839d6dd2e7098ee40b6">all</a>( QString section, QString key, <a class="code" href="classstd_1_1vector.html">std::vector&lt;float&gt;</a>&amp; value ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#aa6041b7843059839d6dd2e7098ee40b6">all</a>( QString section, QString key, <a class="code" href="classstd_1_1vector.html">std::vector&lt;double&gt;</a>&amp; value ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#aa6041b7843059839d6dd2e7098ee40b6">all</a>( QString section, QString key, <a class="code" href="classstd_1_1vector.html">std::vector&lt;std::string&gt;</a>&amp; value ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#aa6041b7843059839d6dd2e7098ee40b6">all</a>( QString section, QString key, <a class="code" href="classstd_1_1vector.html">std::vector&lt;QString&gt;</a>&amp; value ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#aa6041b7843059839d6dd2e7098ee40b6">all</a>( QString section, QString key, QStringList&amp; value ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;</div>
<div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Container&gt;</div>
<div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a7647217ebd86af7aba31dc7fb7516223">setAll</a>( QString section, QString key, <span class="keyword">const</span> Container&amp; value, <span class="keyword">const</span> QList&lt;QStringList&gt;&amp; comments = QList&lt;QStringList&gt;() );</div>
<div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;</div>
<div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a7647217ebd86af7aba31dc7fb7516223">setAll</a>(QString section, QString key, <span class="keyword">const</span> <a class="code" href="classstd_1_1vector.html">std::vector&lt;bool&gt;</a>&amp; value, <span class="keyword">const</span> QList&lt;QStringList&gt;&amp; comments = QList&lt;QStringList&gt;());</div>
<div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a7647217ebd86af7aba31dc7fb7516223">setAll</a>(QString section, QString key, <span class="keyword">const</span> <a class="code" href="classstd_1_1vector.html">std::vector&lt;int&gt;</a>&amp; value, <span class="keyword">const</span> QList&lt;QStringList&gt;&amp; comments = QList&lt;QStringList&gt;());</div>
<div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a7647217ebd86af7aba31dc7fb7516223">setAll</a>(QString section, QString key, <span class="keyword">const</span> <a class="code" href="classstd_1_1vector.html">std::vector&lt;float&gt;</a>&amp; value, <span class="keyword">const</span> QList&lt;QStringList&gt;&amp; comments = QList&lt;QStringList&gt;());</div>
<div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a7647217ebd86af7aba31dc7fb7516223">setAll</a>(QString section, QString key, <span class="keyword">const</span> <a class="code" href="classstd_1_1vector.html">std::vector&lt;double&gt;</a>&amp; value, <span class="keyword">const</span> QList&lt;QStringList&gt;&amp; comments = QList&lt;QStringList&gt;());</div>
<div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a7647217ebd86af7aba31dc7fb7516223">setAll</a>(QString section, QString key, <span class="keyword">const</span> <a class="code" href="classstd_1_1vector.html">std::vector&lt;std::string&gt;</a>&amp; value, <span class="keyword">const</span> QList&lt;QStringList&gt;&amp; comments = QList&lt;QStringList&gt;());</div>
<div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a7647217ebd86af7aba31dc7fb7516223">setAll</a>(QString section, QString key, <span class="keyword">const</span> <a class="code" href="classstd_1_1vector.html">std::vector&lt;QString&gt;</a>&amp; value, <span class="keyword">const</span> QList&lt;QStringList&gt;&amp; comments = QList&lt;QStringList&gt;());</div>
<div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a7647217ebd86af7aba31dc7fb7516223">setAll</a>(QString section, QString key, <span class="keyword">const</span> QStringList&amp; value, <span class="keyword">const</span> QList&lt;QStringList&gt;&amp; comments = QList&lt;QStringList&gt;());</div>
<div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;</div>
<div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> Container&gt;</div>
<div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#aa6041b7843059839d6dd2e7098ee40b6">all</a>( QString section, QHash&lt;QString, Container&gt;&amp; values) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;</div>
<div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#aa6041b7843059839d6dd2e7098ee40b6">all</a>( QString section, QHash&lt;QString, <a class="code" href="classstd_1_1vector.html">std::vector&lt;bool&gt;</a> &gt;&amp; value ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#aa6041b7843059839d6dd2e7098ee40b6">all</a>( QString section, QHash&lt;QString, <a class="code" href="classstd_1_1vector.html">std::vector&lt;int&gt;</a> &gt;&amp; value ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#aa6041b7843059839d6dd2e7098ee40b6">all</a>( QString section, QHash&lt;QString, <a class="code" href="classstd_1_1vector.html">std::vector&lt;float&gt;</a> &gt;&amp; value ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#aa6041b7843059839d6dd2e7098ee40b6">all</a>( QString section, QHash&lt;QString, <a class="code" href="classstd_1_1vector.html">std::vector&lt;double&gt;</a> &gt;&amp; value ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00434"></a><span class="lineno">  434</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#aa6041b7843059839d6dd2e7098ee40b6">all</a>( QString section, QHash&lt;QString, <a class="code" href="classstd_1_1vector.html">std::vector&lt;std::string&gt;</a> &gt;&amp; value ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00440"></a><span class="lineno">  440</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#aa6041b7843059839d6dd2e7098ee40b6">all</a>( QString section, QHash&lt;QString, <a class="code" href="classstd_1_1vector.html">std::vector&lt;QString&gt;</a> &gt;&amp; value ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#aa6041b7843059839d6dd2e7098ee40b6">all</a>( QString section, QHash&lt;QString, QStringList&gt;&amp; value ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160;    </div>
<div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;    QStringList <a class="code" href="classParms.html#a33f350bc103482f983426de27480423f">listSections</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;</div>
<div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00451"></a><span class="lineno"><a class="code" href="structParms_1_1value__t.html">  451</a></span>&#160;    <span class="keyword">struct </span><a class="code" href="structParms_1_1value__t.html">value_t</a></div>
<div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160;    {</div>
<div class="line"><a name="l00453"></a><span class="lineno"><a class="code" href="structParms_1_1value__t.html#a8b69196bbdcf16cf22ed013dd56dd0d7">  453</a></span>&#160;        <a class="code" href="structParms_1_1value__t.html#a8b69196bbdcf16cf22ed013dd56dd0d7">value_t</a>() { }</div>
<div class="line"><a name="l00454"></a><span class="lineno"><a class="code" href="structParms_1_1value__t.html#a5420a9fa1754c8bfbe26c6a20a4f9711">  454</a></span>&#160;        <a class="code" href="structParms_1_1value__t.html#a8b69196bbdcf16cf22ed013dd56dd0d7">value_t</a>(QString v, QStringList c)</div>
<div class="line"><a name="l00455"></a><span class="lineno">  455</span>&#160;            : value(v)</div>
<div class="line"><a name="l00456"></a><span class="lineno">  456</span>&#160;            , <a class="code" href="structParms_1_1value__t.html#a4f6a58ce165fe02aafbdba0e86c259dd">comment</a>(c)</div>
<div class="line"><a name="l00457"></a><span class="lineno">  457</span>&#160;        { }</div>
<div class="line"><a name="l00458"></a><span class="lineno"><a class="code" href="structParms_1_1value__t.html#ab32187e2c01d325d36120e5097061696">  458</a></span>&#160;        QString <a class="code" href="structParms_1_1value__t.html#ab32187e2c01d325d36120e5097061696">value</a>;</div>
<div class="line"><a name="l00459"></a><span class="lineno"><a class="code" href="structParms_1_1value__t.html#a4f6a58ce165fe02aafbdba0e86c259dd">  459</a></span>&#160;        QStringList <a class="code" href="structParms_1_1value__t.html#a4f6a58ce165fe02aafbdba0e86c259dd">comment</a>;</div>
<div class="line"><a name="l00460"></a><span class="lineno">  460</span>&#160;    };</div>
<div class="line"><a name="l00461"></a><span class="lineno">  461</span>&#160;</div>
<div class="line"><a name="l00462"></a><span class="lineno"><a class="code" href="classParms.html#acc426969e9bf5e89a56dd9cbe77e2dfa">  462</a></span>&#160;    <span class="keyword">typedef</span> QList&lt;value_t&gt; <a class="code" href="classParms.html#acc426969e9bf5e89a56dd9cbe77e2dfa">values_t</a>;</div>
<div class="line"><a name="l00463"></a><span class="lineno">  463</span>&#160;</div>
<div class="line"><a name="l00464"></a><span class="lineno"><a class="code" href="structParms_1_1section__t.html">  464</a></span>&#160;    <span class="keyword">struct </span><a class="code" href="structParms_1_1section__t.html">section_t</a></div>
<div class="line"><a name="l00465"></a><span class="lineno">  465</span>&#160;    {</div>
<div class="line"><a name="l00466"></a><span class="lineno"><a class="code" href="structParms_1_1section__t.html#aaa61e85200ca844139b3c91a60af3687">  466</a></span>&#160;        <span class="keyword">typedef</span> QHash&lt;QString,values_t&gt;::const_iterator <a class="code" href="structParms_1_1section__t.html#aaa61e85200ca844139b3c91a60af3687">const_iterator</a>;</div>
<div class="line"><a name="l00467"></a><span class="lineno"><a class="code" href="structParms_1_1section__t.html#a8ea48a876271bed202948862668fa72c">  467</a></span>&#160;        <span class="keyword">typedef</span> QHash&lt;QString,values_t&gt;::iterator <a class="code" href="structParms_1_1section__t.html#a8ea48a876271bed202948862668fa72c">iterator</a>;</div>
<div class="line"><a name="l00468"></a><span class="lineno">  468</span>&#160;</div>
<div class="line"><a name="l00469"></a><span class="lineno"><a class="code" href="structParms_1_1section__t.html#a5223eda8f7aa92ec8d9f1051a8de81dd">  469</a></span>&#160;        QHash&lt;QString,values_t&gt; <a class="code" href="structParms_1_1section__t.html#a5223eda8f7aa92ec8d9f1051a8de81dd">values</a>;</div>
<div class="line"><a name="l00470"></a><span class="lineno"><a class="code" href="structParms_1_1section__t.html#ad80d5aa3d07406fd9c57b38a71abc390">  470</a></span>&#160;        QStringList <a class="code" href="structParms_1_1section__t.html#ad80d5aa3d07406fd9c57b38a71abc390">comment</a>;</div>
<div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160;</div>
<div class="line"><a name="l00472"></a><span class="lineno"><a class="code" href="structParms_1_1section__t.html#aa0da9b2c971b949d9c8d635e8d061adf">  472</a></span>&#160;        <a class="code" href="classParms.html#acc426969e9bf5e89a56dd9cbe77e2dfa">values_t</a>&amp; <a class="code" href="structParms_1_1section__t.html#aa0da9b2c971b949d9c8d635e8d061adf">operator[]</a>(<span class="keyword">const</span> QString&amp; key) { <span class="keywordflow">return</span> <a class="code" href="structParms_1_1section__t.html#a5223eda8f7aa92ec8d9f1051a8de81dd">values</a>[key]; }</div>
<div class="line"><a name="l00473"></a><span class="lineno"><a class="code" href="structParms_1_1section__t.html#af822b34b36b63a5c89332f5143732839">  473</a></span>&#160;        <span class="keyword">const</span> <a class="code" href="classParms.html#acc426969e9bf5e89a56dd9cbe77e2dfa">values_t</a> <a class="code" href="structParms_1_1section__t.html#af822b34b36b63a5c89332f5143732839">value</a>(<span class="keyword">const</span> QString&amp; key)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="structParms_1_1section__t.html#a5223eda8f7aa92ec8d9f1051a8de81dd">values</a>.value(key); }</div>
<div class="line"><a name="l00474"></a><span class="lineno"><a class="code" href="structParms_1_1section__t.html#ac1b7ad551296323f8d6f29d51b96c679">  474</a></span>&#160;        QStringList <a class="code" href="structParms_1_1section__t.html#ac1b7ad551296323f8d6f29d51b96c679">keys</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="structParms_1_1section__t.html#a5223eda8f7aa92ec8d9f1051a8de81dd">values</a>.keys(); }</div>
<div class="line"><a name="l00475"></a><span class="lineno"><a class="code" href="structParms_1_1section__t.html#a56578d4a5459c7726fc7b96bcecf1fab">  475</a></span>&#160;        <a class="code" href="structParms_1_1section__t.html#a8ea48a876271bed202948862668fa72c">iterator</a> <a class="code" href="structParms_1_1section__t.html#a56578d4a5459c7726fc7b96bcecf1fab">begin</a>() { <span class="keywordflow">return</span> <a class="code" href="structParms_1_1section__t.html#a5223eda8f7aa92ec8d9f1051a8de81dd">values</a>.begin(); }</div>
<div class="line"><a name="l00476"></a><span class="lineno"><a class="code" href="structParms_1_1section__t.html#ad3b76cc533abadefae38ac69d010bb5a">  476</a></span>&#160;        <a class="code" href="structParms_1_1section__t.html#a8ea48a876271bed202948862668fa72c">iterator</a> <a class="code" href="structParms_1_1section__t.html#ad3b76cc533abadefae38ac69d010bb5a">end</a>() { <span class="keywordflow">return</span> <a class="code" href="structParms_1_1section__t.html#a5223eda8f7aa92ec8d9f1051a8de81dd">values</a>.end(); }</div>
<div class="line"><a name="l00477"></a><span class="lineno"><a class="code" href="structParms_1_1section__t.html#a63d8660fd88b0b0b4e5597df806f15e4">  477</a></span>&#160;        <a class="code" href="structParms_1_1section__t.html#aaa61e85200ca844139b3c91a60af3687">const_iterator</a> <a class="code" href="structParms_1_1section__t.html#a63d8660fd88b0b0b4e5597df806f15e4">begin</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="structParms_1_1section__t.html#a5223eda8f7aa92ec8d9f1051a8de81dd">values</a>.begin(); }</div>
<div class="line"><a name="l00478"></a><span class="lineno"><a class="code" href="structParms_1_1section__t.html#a24e4ff7741d8512e68a2ecc9d86b637d">  478</a></span>&#160;        <a class="code" href="structParms_1_1section__t.html#aaa61e85200ca844139b3c91a60af3687">const_iterator</a> <a class="code" href="structParms_1_1section__t.html#a24e4ff7741d8512e68a2ecc9d86b637d">end</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="structParms_1_1section__t.html#a5223eda8f7aa92ec8d9f1051a8de81dd">values</a>.end(); }</div>
<div class="line"><a name="l00479"></a><span class="lineno"><a class="code" href="structParms_1_1section__t.html#a876ded56ac90ba94c41db4f0dc184186">  479</a></span>&#160;        <a class="code" href="structParms_1_1section__t.html#a8ea48a876271bed202948862668fa72c">iterator</a> <a class="code" href="structParms_1_1section__t.html#a876ded56ac90ba94c41db4f0dc184186">find</a>(<span class="keyword">const</span> QString&amp; key) { <span class="keywordflow">return</span> <a class="code" href="structParms_1_1section__t.html#a5223eda8f7aa92ec8d9f1051a8de81dd">values</a>.find(key); }</div>
<div class="line"><a name="l00480"></a><span class="lineno"><a class="code" href="structParms_1_1section__t.html#a1d9aa82ba2c30d8c4ff9d693198b8c23">  480</a></span>&#160;        <a class="code" href="structParms_1_1section__t.html#aaa61e85200ca844139b3c91a60af3687">const_iterator</a> <a class="code" href="structParms_1_1section__t.html#a1d9aa82ba2c30d8c4ff9d693198b8c23">find</a>(<span class="keyword">const</span> QString&amp; key)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="structParms_1_1section__t.html#a5223eda8f7aa92ec8d9f1051a8de81dd">values</a>.find(key); }</div>
<div class="line"><a name="l00481"></a><span class="lineno">  481</span>&#160;    };</div>
<div class="line"><a name="l00482"></a><span class="lineno">  482</span>&#160;</div>
<div class="line"><a name="l00483"></a><span class="lineno"><a class="code" href="classParms.html#a4202397cc5ea12ebdcf778e6c1fa4316">  483</a></span>&#160;    <span class="keyword">typedef</span> QHash&lt;QString, section_t&gt; <a class="code" href="classParms.html#a4202397cc5ea12ebdcf778e6c1fa4316">parameters_t</a>;</div>
<div class="line"><a name="l00484"></a><span class="lineno">  484</span>&#160;</div>
<div class="line"><a name="l00485"></a><span class="lineno">  485</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a996412338909bf6412976e227051a6c1">setValues</a>( QString section, QString key, <span class="keyword">const</span> <a class="code" href="classParms.html#acc426969e9bf5e89a56dd9cbe77e2dfa">values_t</a>&amp; values );</div>
<div class="line"><a name="l00486"></a><span class="lineno"><a class="code" href="classParms.html#a41b9a8f363cedfeccd782cb165873dca">  486</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a41b9a8f363cedfeccd782cb165873dca">setValue</a>(QString section, QString key, <span class="keyword">const</span> <a class="code" href="structParms_1_1value__t.html">value_t</a>&amp; value)</div>
<div class="line"><a name="l00487"></a><span class="lineno">  487</span>&#160;    {</div>
<div class="line"><a name="l00488"></a><span class="lineno">  488</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classParms.html#a996412338909bf6412976e227051a6c1">setValues</a>(section, key, <a class="code" href="classParms.html#acc426969e9bf5e89a56dd9cbe77e2dfa">values_t</a>() &lt;&lt; value);</div>
<div class="line"><a name="l00489"></a><span class="lineno">  489</span>&#160;    }</div>
<div class="line"><a name="l00490"></a><span class="lineno">  490</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a9d945adcfdec06f9101784fa0444e9ed">addValue</a>(QString section, QString key, <span class="keyword">const</span> value_t&amp; value);</div>
<div class="line"><a name="l00491"></a><span class="lineno">  491</span>&#160;</div>
<div class="line"><a name="l00497"></a><span class="lineno">  497</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#aa97f61a21d8b4253bdb13291bc6fe705">extractValues</a>( QString section, QString key, QStringList&amp; values, <span class="keywordtype">bool</span> checkExist ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00498"></a><span class="lineno">  498</span>&#160;</div>
<div class="line"><a name="l00507"></a><span class="lineno">  507</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#ad6a4dd0a3a4d43815ff643922d67856d">readValue</a>( QString value, <span class="keywordtype">bool</span>&amp; variable ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00515"></a><span class="lineno">  515</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#ad6a4dd0a3a4d43815ff643922d67856d">readValue</a>( QString value, std::string&amp; variable ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00523"></a><span class="lineno">  523</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#ad6a4dd0a3a4d43815ff643922d67856d">readValue</a>( QString value, QString&amp; variable ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00532"></a><span class="lineno">  532</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00533"></a><span class="lineno">  533</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#ad6a4dd0a3a4d43815ff643922d67856d">readValue</a>( QString value, <a class="code" href="classstd_1_1vector.html">std::vector&lt;T&gt;</a>&amp; variable ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00542"></a><span class="lineno">  542</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00543"></a><span class="lineno">  543</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#ad6a4dd0a3a4d43815ff643922d67856d">readValue</a>( QString value, std::list&lt;T&gt;&amp; variable ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00552"></a><span class="lineno">  552</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00553"></a><span class="lineno">  553</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#ad6a4dd0a3a4d43815ff643922d67856d">readValue</a>( QString value, std::set&lt;T&gt;&amp; variable ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00562"></a><span class="lineno">  562</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00563"></a><span class="lineno">  563</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#ad6a4dd0a3a4d43815ff643922d67856d">readValue</a>( QString value, T&amp; variable ) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00564"></a><span class="lineno">  564</span>&#160;</div>
<div class="line"><a name="l00565"></a><span class="lineno">  565</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> InsertIterator&gt;</div>
<div class="line"><a name="l00566"></a><span class="lineno">  566</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#ab4eafc9e4c197cadc2f9697ee250e2c8">readContainer</a>( QString value, InsertIterator container) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00567"></a><span class="lineno">  567</span>&#160;</div>
<div class="line"><a name="l00568"></a><span class="lineno">  568</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a1c64f37a3c1f45e82ca70bd0b70bf7e0">writeValue</a>( QString&amp; value, <span class="keyword">const</span> <span class="keywordtype">bool</span>&amp; variable );</div>
<div class="line"><a name="l00569"></a><span class="lineno">  569</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a1c64f37a3c1f45e82ca70bd0b70bf7e0">writeValue</a>( QString&amp; value, <span class="keyword">const</span> std::string&amp; variable );</div>
<div class="line"><a name="l00570"></a><span class="lineno">  570</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a1c64f37a3c1f45e82ca70bd0b70bf7e0">writeValue</a>( QString&amp; value, QString variable );</div>
<div class="line"><a name="l00571"></a><span class="lineno">  571</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00572"></a><span class="lineno">  572</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a1c64f37a3c1f45e82ca70bd0b70bf7e0">writeValue</a>( QString&amp; value, <span class="keyword">const</span> <a class="code" href="classstd_1_1vector.html">std::vector&lt;T&gt;</a>&amp; variable );</div>
<div class="line"><a name="l00573"></a><span class="lineno">  573</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00574"></a><span class="lineno">  574</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a1c64f37a3c1f45e82ca70bd0b70bf7e0">writeValue</a>( QString&amp; value, <span class="keyword">const</span> std::list&lt;T&gt;&amp; variable );</div>
<div class="line"><a name="l00575"></a><span class="lineno">  575</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00576"></a><span class="lineno">  576</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a1c64f37a3c1f45e82ca70bd0b70bf7e0">writeValue</a>( QString&amp; value, <span class="keyword">const</span> std::set&lt;T&gt;&amp; variable );</div>
<div class="line"><a name="l00577"></a><span class="lineno">  577</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00578"></a><span class="lineno">  578</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a1c64f37a3c1f45e82ca70bd0b70bf7e0">writeValue</a>( QString&amp; value, <span class="keyword">const</span> T&amp; variable );</div>
<div class="line"><a name="l00579"></a><span class="lineno">  579</span>&#160;</div>
<div class="line"><a name="l00580"></a><span class="lineno">  580</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Iterator&gt;</div>
<div class="line"><a name="l00581"></a><span class="lineno">  581</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a8a374310cd30d52e940471d130fd9b00">writeContainer</a>( QString&amp; value, Iterator first, Iterator last);</div>
<div class="line"><a name="l00582"></a><span class="lineno">  582</span>&#160;</div>
<div class="line"><a name="l00583"></a><span class="lineno">  583</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00584"></a><span class="lineno">  584</span>&#160;    <span class="keywordtype">bool</span> <span class="keyword">get</span>(QString section, QString key, T&amp; value, <span class="keywordtype">bool</span> checkExist) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00585"></a><span class="lineno">  585</span>&#160;</div>
<div class="line"><a name="l00590"></a><span class="lineno"><a class="code" href="classParms.html#a4241ac27fefd3fbfd3ecd9e9c3f048c9">  590</a></span>&#160;    <a class="code" href="classParms.html#a4202397cc5ea12ebdcf778e6c1fa4316">parameters_t</a> <a class="code" href="classParms.html#a4241ac27fefd3fbfd3ecd9e9c3f048c9">Parameters</a>;</div>
<div class="line"><a name="l00591"></a><span class="lineno">  591</span>&#160;</div>
<div class="line"><a name="l00595"></a><span class="lineno"><a class="code" href="classParms.html#a304288b4be84e292ebe1dad50aabe59f">  595</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classParms.html#a304288b4be84e292ebe1dad50aabe59f">VerboseLevel</a>;</div>
<div class="line"><a name="l00596"></a><span class="lineno">  596</span>&#160;</div>
<div class="line"><a name="l00601"></a><span class="lineno"><a class="code" href="classParms.html#aabaf831218f19258225e6160f926d3e5">  601</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#aabaf831218f19258225e6160f926d3e5">CheckExist</a>;</div>
<div class="line"><a name="l00602"></a><span class="lineno">  602</span>&#160;</div>
<div class="line"><a name="l00606"></a><span class="lineno"><a class="code" href="classParms.html#a8ca128b8c8e4cc8655486397ca04080b">  606</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classParms.html#a8ca128b8c8e4cc8655486397ca04080b">loaded</a>;</div>
<div class="line"><a name="l00607"></a><span class="lineno">  607</span>&#160;};</div>
<div class="line"><a name="l00608"></a><span class="lineno">  608</span>&#160;</div>
<div class="line"><a name="l00609"></a><span class="lineno">  609</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> InsertIterator&gt;</div>
<div class="line"><a name="l00610"></a><span class="lineno"><a class="code" href="classParms.html#ab4eafc9e4c197cadc2f9697ee250e2c8">  610</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classParms.html#ab4eafc9e4c197cadc2f9697ee250e2c8">Parms::readContainer</a>( QString value, InsertIterator it)<span class="keyword"> const</span></div>
<div class="line"><a name="l00611"></a><span class="lineno">  611</span>&#160;<span class="keyword"></span>{</div>
<div class="line"><a name="l00612"></a><span class="lineno">  612</span>&#160;    QString val(value);</div>
<div class="line"><a name="l00613"></a><span class="lineno">  613</span>&#160;    QTextStream iss(&amp;val, QIODevice::ReadOnly);</div>
<div class="line"><a name="l00614"></a><span class="lineno">  614</span>&#160;    <span class="keywordflow">while</span>(!iss.atEnd() and iss.status() == QTextStream::Ok)</div>
<div class="line"><a name="l00615"></a><span class="lineno">  615</span>&#160;    {</div>
<div class="line"><a name="l00616"></a><span class="lineno">  616</span>&#160;        T v;</div>
<div class="line"><a name="l00617"></a><span class="lineno">  617</span>&#160;        iss &gt;&gt; v;</div>
<div class="line"><a name="l00618"></a><span class="lineno">  618</span>&#160;        *it++ = v;</div>
<div class="line"><a name="l00619"></a><span class="lineno">  619</span>&#160;    }</div>
<div class="line"><a name="l00620"></a><span class="lineno">  620</span>&#160;    <span class="keywordflow">return</span> iss.status() == QTextStream::Ok;</div>
<div class="line"><a name="l00621"></a><span class="lineno">  621</span>&#160;}</div>
<div class="line"><a name="l00622"></a><span class="lineno">  622</span>&#160;</div>
<div class="line"><a name="l00623"></a><span class="lineno">  623</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00624"></a><span class="lineno"><a class="code" href="classParms.html#a816784c573465ec83dfdd75a89cb028e">  624</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classParms.html#ad6a4dd0a3a4d43815ff643922d67856d">Parms::readValue</a>( QString value, <a class="code" href="classstd_1_1vector.html">std::vector&lt;T&gt;</a>&amp; variable )<span class="keyword"> const</span></div>
<div class="line"><a name="l00625"></a><span class="lineno">  625</span>&#160;<span class="keyword"></span>{</div>
<div class="line"><a name="l00626"></a><span class="lineno">  626</span>&#160;    <span class="keywordflow">return</span> readContainer&lt;T&gt;(value, std::back_insert_iterator&lt;std::vector&lt;T&gt; &gt;(variable));</div>
<div class="line"><a name="l00627"></a><span class="lineno">  627</span>&#160;}</div>
<div class="line"><a name="l00628"></a><span class="lineno">  628</span>&#160;</div>
<div class="line"><a name="l00629"></a><span class="lineno">  629</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00630"></a><span class="lineno"><a class="code" href="classParms.html#a2792056602cceee4d24f7840f87479a6">  630</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classParms.html#ad6a4dd0a3a4d43815ff643922d67856d">Parms::readValue</a>( QString value, std::list&lt;T&gt;&amp; variable )<span class="keyword"> const</span></div>
<div class="line"><a name="l00631"></a><span class="lineno">  631</span>&#160;<span class="keyword"></span>{</div>
<div class="line"><a name="l00632"></a><span class="lineno">  632</span>&#160;    <span class="keywordflow">return</span> readContainer&lt;T&gt;(value, std::back_insert_iterator&lt;std::list&lt;T&gt; &gt;(variable));</div>
<div class="line"><a name="l00633"></a><span class="lineno">  633</span>&#160;}</div>
<div class="line"><a name="l00634"></a><span class="lineno">  634</span>&#160;</div>
<div class="line"><a name="l00635"></a><span class="lineno">  635</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00636"></a><span class="lineno"><a class="code" href="classParms.html#a938d02ab98299b40a00251c5c02c086a">  636</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classParms.html#ad6a4dd0a3a4d43815ff643922d67856d">Parms::readValue</a>( QString value, std::set&lt;T&gt;&amp; variable )<span class="keyword"> const</span></div>
<div class="line"><a name="l00637"></a><span class="lineno">  637</span>&#160;<span class="keyword"></span>{</div>
<div class="line"><a name="l00638"></a><span class="lineno">  638</span>&#160;    <span class="keywordflow">return</span> readContainer&lt;T&gt;(value, std::insert_iterator&lt;std::set&lt;T&gt; &gt;(variable, variable.end()));</div>
<div class="line"><a name="l00639"></a><span class="lineno">  639</span>&#160;}</div>
<div class="line"><a name="l00640"></a><span class="lineno">  640</span>&#160;</div>
<div class="line"><a name="l00641"></a><span class="lineno">  641</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00642"></a><span class="lineno"><a class="code" href="classParms.html#a02f9131a801f181a9f41632e32b36d14">  642</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classParms.html#ad6a4dd0a3a4d43815ff643922d67856d">Parms::readValue</a>( QString value, T&amp; variable )<span class="keyword"> const</span></div>
<div class="line"><a name="l00643"></a><span class="lineno">  643</span>&#160;<span class="keyword"></span>{</div>
<div class="line"><a name="l00644"></a><span class="lineno">  644</span>&#160;    QString val(value);</div>
<div class="line"><a name="l00645"></a><span class="lineno">  645</span>&#160;    QTextStream iss(&amp;val, QIODevice::ReadOnly);</div>
<div class="line"><a name="l00646"></a><span class="lineno">  646</span>&#160;    iss &gt;&gt; variable;</div>
<div class="line"><a name="l00647"></a><span class="lineno">  647</span>&#160;    <span class="keywordflow">return</span> iss.status() == QTextStream::Ok;</div>
<div class="line"><a name="l00648"></a><span class="lineno">  648</span>&#160;}</div>
<div class="line"><a name="l00649"></a><span class="lineno">  649</span>&#160;</div>
<div class="line"><a name="l00650"></a><span class="lineno">  650</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00651"></a><span class="lineno"><a class="code" href="classParms.html#a3a292306fef32acb636751b874a62950">  651</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classParms.html#a3a292306fef32acb636751b874a62950">Parms::operator()</a>( QString section, QString key, T&amp; value )<span class="keyword"> const</span></div>
<div class="line"><a name="l00652"></a><span class="lineno">  652</span>&#160;<span class="keyword"></span>{</div>
<div class="line"><a name="l00653"></a><span class="lineno">  653</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">get</span>(section, key, value, <span class="keyword">true</span>);</div>
<div class="line"><a name="l00654"></a><span class="lineno">  654</span>&#160;}</div>
<div class="line"><a name="l00655"></a><span class="lineno">  655</span>&#160;</div>
<div class="line"><a name="l00656"></a><span class="lineno">  656</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00657"></a><span class="lineno"><a class="code" href="classParms.html#aa6b4b574235c7284bb1020b3d0b2484f">  657</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classParms.html#aa6b4b574235c7284bb1020b3d0b2484f">Parms::get</a>( QString section, QString key, T&amp; value, <span class="keywordtype">bool</span> checkExist)<span class="keyword"> const</span></div>
<div class="line"><a name="l00658"></a><span class="lineno">  658</span>&#160;<span class="keyword"></span>{</div>
<div class="line"><a name="l00659"></a><span class="lineno">  659</span>&#160;    QStringList values;</div>
<div class="line"><a name="l00660"></a><span class="lineno">  660</span>&#160;    <span class="keywordflow">if</span>( !<a class="code" href="classParms.html#aa97f61a21d8b4253bdb13291bc6fe705">extractValues</a>( section, key, values, checkExist ) )</div>
<div class="line"><a name="l00661"></a><span class="lineno">  661</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00662"></a><span class="lineno">  662</span>&#160;</div>
<div class="line"><a name="l00663"></a><span class="lineno">  663</span>&#160;    <span class="keywordflow">if</span>( ( values.size() &gt; 1 ) &amp;&amp; ( <a class="code" href="classParms.html#a304288b4be84e292ebe1dad50aabe59f">VerboseLevel</a> &gt; 1 ) )</div>
<div class="line"><a name="l00664"></a><span class="lineno">  664</span>&#160;    {</div>
<div class="line"><a name="l00665"></a><span class="lineno">  665</span>&#160;        <a class="code" href="classParms.html#aa44d348824ac5264b1e5c256ec8187e0">err</a> &lt;&lt; <span class="stringliteral">&quot;Parms::operator():Warning multiple value for key [&quot;</span> &lt;&lt; section &lt;&lt; <span class="stringliteral">&quot;]&quot;</span></div>
<div class="line"><a name="l00666"></a><span class="lineno">  666</span>&#160;            &lt;&lt; key &lt;&lt; <span class="stringliteral">&quot;, last one used.\n&quot;</span> &lt;&lt; flush;</div>
<div class="line"><a name="l00667"></a><span class="lineno">  667</span>&#160;    }</div>
<div class="line"><a name="l00668"></a><span class="lineno">  668</span>&#160;</div>
<div class="line"><a name="l00669"></a><span class="lineno">  669</span>&#160;    <span class="keywordflow">if</span>( !<a class="code" href="classParms.html#ad6a4dd0a3a4d43815ff643922d67856d">readValue</a>( values.back(), value ) )</div>
<div class="line"><a name="l00670"></a><span class="lineno">  670</span>&#160;    {</div>
<div class="line"><a name="l00671"></a><span class="lineno">  671</span>&#160;        <span class="keywordflow">if</span>( <a class="code" href="classParms.html#a304288b4be84e292ebe1dad50aabe59f">VerboseLevel</a> &gt; 0 )</div>
<div class="line"><a name="l00672"></a><span class="lineno">  672</span>&#160;        {</div>
<div class="line"><a name="l00673"></a><span class="lineno">  673</span>&#160;            <a class="code" href="classParms.html#aa44d348824ac5264b1e5c256ec8187e0">err</a> &lt;&lt; <span class="stringliteral">&quot;Parms::operator():Error getting value for key [&quot;</span> &lt;&lt; section &lt;&lt; <span class="stringliteral">&quot;]&quot;</span> &lt;&lt;  key</div>
<div class="line"><a name="l00674"></a><span class="lineno">  674</span>&#160;                &lt;&lt; <span class="stringliteral">&quot; value &quot;</span> &lt;&lt; values.back() &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span> &lt;&lt; flush;</div>
<div class="line"><a name="l00675"></a><span class="lineno">  675</span>&#160;        }</div>
<div class="line"><a name="l00676"></a><span class="lineno">  676</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00677"></a><span class="lineno">  677</span>&#160;    }</div>
<div class="line"><a name="l00678"></a><span class="lineno">  678</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00679"></a><span class="lineno">  679</span>&#160;}</div>
<div class="line"><a name="l00680"></a><span class="lineno">  680</span>&#160;</div>
<div class="line"><a name="l00681"></a><span class="lineno">  681</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00682"></a><span class="lineno"><a class="code" href="classParms.html#a1e97084b6e429e5cd52f331587933c9c">  682</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classParms.html#a3a292306fef32acb636751b874a62950">Parms::operator()</a>( QString section, QString key, T&amp; value, <span class="keyword">const</span> T&amp; def )<span class="keyword"> const</span></div>
<div class="line"><a name="l00683"></a><span class="lineno">  683</span>&#160;<span class="keyword"></span>{</div>
<div class="line"><a name="l00684"></a><span class="lineno">  684</span>&#160;    <span class="keywordtype">bool</span> found = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00685"></a><span class="lineno">  685</span>&#160;    <span class="keywordflow">if</span>( !( *<span class="keyword">this</span> )( section, key, value ) )</div>
<div class="line"><a name="l00686"></a><span class="lineno">  686</span>&#160;    {</div>
<div class="line"><a name="l00687"></a><span class="lineno">  687</span>&#160;        found = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00688"></a><span class="lineno">  688</span>&#160;        <span class="keywordflow">if</span>( <a class="code" href="classParms.html#a304288b4be84e292ebe1dad50aabe59f">VerboseLevel</a> &gt; 2 )</div>
<div class="line"><a name="l00689"></a><span class="lineno">  689</span>&#160;        {</div>
<div class="line"><a name="l00690"></a><span class="lineno">  690</span>&#160;            <a class="code" href="classParms.html#aa44d348824ac5264b1e5c256ec8187e0">err</a> &lt;&lt; <span class="stringliteral">&quot;Parms::operator()::Info key [&quot;</span> &lt;&lt; section &lt;&lt; <span class="stringliteral">&quot;]&quot;</span></div>
<div class="line"><a name="l00691"></a><span class="lineno">  691</span>&#160;                &lt;&lt; key &lt;&lt; <span class="stringliteral">&quot; not found, using default value&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00692"></a><span class="lineno">  692</span>&#160;        }</div>
<div class="line"><a name="l00693"></a><span class="lineno">  693</span>&#160;        value = def;</div>
<div class="line"><a name="l00694"></a><span class="lineno">  694</span>&#160;    }</div>
<div class="line"><a name="l00695"></a><span class="lineno">  695</span>&#160;    <span class="keywordflow">return</span> found;</div>
<div class="line"><a name="l00696"></a><span class="lineno">  696</span>&#160;}</div>
<div class="line"><a name="l00697"></a><span class="lineno">  697</span>&#160;</div>
<div class="line"><a name="l00698"></a><span class="lineno">  698</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> Container&gt;</div>
<div class="line"><a name="l00699"></a><span class="lineno"><a class="code" href="classParms.html#aa6041b7843059839d6dd2e7098ee40b6">  699</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classParms.html#aa6041b7843059839d6dd2e7098ee40b6">Parms::all</a>( QString section, QString key, Container&amp; value )<span class="keyword"> const</span></div>
<div class="line"><a name="l00700"></a><span class="lineno">  700</span>&#160;<span class="keyword"></span>{</div>
<div class="line"><a name="l00701"></a><span class="lineno">  701</span>&#160;    <span class="keywordtype">bool</span> valid = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00702"></a><span class="lineno">  702</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> Container::value_type T;</div>
<div class="line"><a name="l00703"></a><span class="lineno">  703</span>&#160;    QStringList values;</div>
<div class="line"><a name="l00704"></a><span class="lineno">  704</span>&#160;    <span class="keywordflow">if</span>( !<a class="code" href="classParms.html#aa97f61a21d8b4253bdb13291bc6fe705">extractValues</a>( section, key, values, <span class="keyword">false</span> ) )</div>
<div class="line"><a name="l00705"></a><span class="lineno">  705</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00706"></a><span class="lineno">  706</span>&#160;    value.clear();</div>
<div class="line"><a name="l00707"></a><span class="lineno">  707</span>&#160;    std::insert_iterator&lt;Container&gt; it(value, value.end());</div>
<div class="line"><a name="l00708"></a><span class="lineno">  708</span>&#160;    <span class="keywordflow">foreach</span>( QString val, values )</div>
<div class="line"><a name="l00709"></a><span class="lineno">  709</span>&#160;    {</div>
<div class="line"><a name="l00710"></a><span class="lineno">  710</span>&#160;        T single_value;</div>
<div class="line"><a name="l00711"></a><span class="lineno">  711</span>&#160;        <span class="keywordflow">if</span>( <a class="code" href="classParms.html#ad6a4dd0a3a4d43815ff643922d67856d">readValue</a>( val, single_value ) )</div>
<div class="line"><a name="l00712"></a><span class="lineno">  712</span>&#160;        {</div>
<div class="line"><a name="l00713"></a><span class="lineno">  713</span>&#160;            *it++ = (<span class="keyword">const</span> T&amp;)single_value;</div>
<div class="line"><a name="l00714"></a><span class="lineno">  714</span>&#160;        }</div>
<div class="line"><a name="l00715"></a><span class="lineno">  715</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00716"></a><span class="lineno">  716</span>&#160;        {</div>
<div class="line"><a name="l00717"></a><span class="lineno">  717</span>&#160;            <span class="keywordflow">if</span>( <a class="code" href="classParms.html#a304288b4be84e292ebe1dad50aabe59f">VerboseLevel</a> &gt; 2 )</div>
<div class="line"><a name="l00718"></a><span class="lineno">  718</span>&#160;            {</div>
<div class="line"><a name="l00719"></a><span class="lineno">  719</span>&#160;                <a class="code" href="classParms.html#aa44d348824ac5264b1e5c256ec8187e0">err</a> &lt;&lt; <span class="stringliteral">&quot;Parms::all:Error reading key [&quot;</span> &lt;&lt; section &lt;&lt; <span class="stringliteral">&quot;]&quot;</span> &lt;&lt; key</div>
<div class="line"><a name="l00720"></a><span class="lineno">  720</span>&#160;                    &lt;&lt; <span class="stringliteral">&quot; with value &quot;</span> &lt;&lt; val &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span> &lt;&lt; flush;</div>
<div class="line"><a name="l00721"></a><span class="lineno">  721</span>&#160;            }</div>
<div class="line"><a name="l00722"></a><span class="lineno">  722</span>&#160;            valid = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00723"></a><span class="lineno">  723</span>&#160;        }</div>
<div class="line"><a name="l00724"></a><span class="lineno">  724</span>&#160;    }</div>
<div class="line"><a name="l00725"></a><span class="lineno">  725</span>&#160;    <span class="keywordflow">return</span> valid;</div>
<div class="line"><a name="l00726"></a><span class="lineno">  726</span>&#160;}</div>
<div class="line"><a name="l00727"></a><span class="lineno">  727</span>&#160;</div>
<div class="line"><a name="l00728"></a><span class="lineno">  728</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> Container&gt;</div>
<div class="line"><a name="l00729"></a><span class="lineno"><a class="code" href="classParms.html#a45c7f59b73585e8e4d91a70dddcbb369">  729</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classParms.html#aa6041b7843059839d6dd2e7098ee40b6">Parms::all</a>( QString section, QHash&lt;QString, Container&gt;&amp; result )<span class="keyword"> const</span></div>
<div class="line"><a name="l00730"></a><span class="lineno">  730</span>&#160;<span class="keyword"></span>{</div>
<div class="line"><a name="l00731"></a><span class="lineno">  731</span>&#160;    <span class="keyword">typename</span> parameters_t::const_iterator found = <a class="code" href="classParms.html#a4241ac27fefd3fbfd3ecd9e9c3f048c9">Parameters</a>.find(section);</div>
<div class="line"><a name="l00732"></a><span class="lineno">  732</span>&#160;    <span class="keywordflow">if</span>(found == <a class="code" href="classParms.html#a4241ac27fefd3fbfd3ecd9e9c3f048c9">Parameters</a>.end()) <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00733"></a><span class="lineno">  733</span>&#160;    <span class="keyword">const</span> <a class="code" href="structParms_1_1section__t.html">section_t</a>&amp; sec = *found;</div>
<div class="line"><a name="l00734"></a><span class="lineno">  734</span>&#160;    result.clear();</div>
<div class="line"><a name="l00735"></a><span class="lineno">  735</span>&#160;    <span class="keywordtype">bool</span> valid = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00736"></a><span class="lineno">  736</span>&#160;    <span class="keywordflow">for</span>(<a class="code" href="structParms_1_1section__t.html#aaa61e85200ca844139b3c91a60af3687">section_t::const_iterator</a> it = sec.<a class="code" href="structParms_1_1section__t.html#a56578d4a5459c7726fc7b96bcecf1fab">begin</a>() ; it != sec.<a class="code" href="structParms_1_1section__t.html#ad3b76cc533abadefae38ac69d010bb5a">end</a>() ; ++it)</div>
<div class="line"><a name="l00737"></a><span class="lineno">  737</span>&#160;    {</div>
<div class="line"><a name="l00738"></a><span class="lineno">  738</span>&#160;        QString key = it.key();</div>
<div class="line"><a name="l00739"></a><span class="lineno">  739</span>&#160;        Container&amp; value = result[key];</div>
<div class="line"><a name="l00740"></a><span class="lineno">  740</span>&#160;        value.clear();</div>
<div class="line"><a name="l00741"></a><span class="lineno">  741</span>&#160;        <span class="keywordflow">foreach</span>( <span class="keyword">const</span> <a class="code" href="structParms_1_1value__t.html">value_t</a>&amp; val, it.<a class="code" href="structParms_1_1value__t.html#ab32187e2c01d325d36120e5097061696">value</a>() )</div>
<div class="line"><a name="l00742"></a><span class="lineno">  742</span>&#160;        {</div>
<div class="line"><a name="l00743"></a><span class="lineno">  743</span>&#160;            T single_value;</div>
<div class="line"><a name="l00744"></a><span class="lineno">  744</span>&#160;            <span class="keywordflow">if</span>( <a class="code" href="classParms.html#ad6a4dd0a3a4d43815ff643922d67856d">readValue</a>( val.<a class="code" href="structParms_1_1value__t.html#ab32187e2c01d325d36120e5097061696">value</a>, single_value ) )</div>
<div class="line"><a name="l00745"></a><span class="lineno">  745</span>&#160;            {</div>
<div class="line"><a name="l00746"></a><span class="lineno">  746</span>&#160;                value.push_back( single_value );</div>
<div class="line"><a name="l00747"></a><span class="lineno">  747</span>&#160;            }</div>
<div class="line"><a name="l00748"></a><span class="lineno">  748</span>&#160;            <span class="keywordflow">else</span></div>
<div class="line"><a name="l00749"></a><span class="lineno">  749</span>&#160;            {</div>
<div class="line"><a name="l00750"></a><span class="lineno">  750</span>&#160;                <span class="keywordflow">if</span>( <a class="code" href="classParms.html#a304288b4be84e292ebe1dad50aabe59f">VerboseLevel</a> &gt; 2 )</div>
<div class="line"><a name="l00751"></a><span class="lineno">  751</span>&#160;                {</div>
<div class="line"><a name="l00752"></a><span class="lineno">  752</span>&#160;                    <a class="code" href="classParms.html#aa44d348824ac5264b1e5c256ec8187e0">err</a> &lt;&lt; <span class="stringliteral">&quot;Parms::all:Error reading key [&quot;</span> &lt;&lt; section &lt;&lt; <span class="stringliteral">&quot;]&quot;</span> &lt;&lt; key</div>
<div class="line"><a name="l00753"></a><span class="lineno">  753</span>&#160;                        &lt;&lt; <span class="stringliteral">&quot; with value &quot;</span> &lt;&lt; val.<a class="code" href="structParms_1_1value__t.html#ab32187e2c01d325d36120e5097061696">value</a> &lt;&lt; endl;</div>
<div class="line"><a name="l00754"></a><span class="lineno">  754</span>&#160;                }</div>
<div class="line"><a name="l00755"></a><span class="lineno">  755</span>&#160;                valid = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00756"></a><span class="lineno">  756</span>&#160;            }</div>
<div class="line"><a name="l00757"></a><span class="lineno">  757</span>&#160;        }</div>
<div class="line"><a name="l00758"></a><span class="lineno">  758</span>&#160;    }</div>
<div class="line"><a name="l00759"></a><span class="lineno">  759</span>&#160;    <span class="keywordflow">return</span> valid;</div>
<div class="line"><a name="l00760"></a><span class="lineno">  760</span>&#160;}</div>
<div class="line"><a name="l00761"></a><span class="lineno">  761</span>&#160;</div>
<div class="line"><a name="l00762"></a><span class="lineno">  762</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00763"></a><span class="lineno"><a class="code" href="classParms.html#a383cdbdd3ee2ed4007b9aba301259be2">  763</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classParms.html#a1c64f37a3c1f45e82ca70bd0b70bf7e0">Parms::writeValue</a>(QString&amp; value, <span class="keyword">const</span> <a class="code" href="classstd_1_1vector.html">std::vector&lt;T&gt;</a>&amp; variable)</div>
<div class="line"><a name="l00764"></a><span class="lineno">  764</span>&#160;{</div>
<div class="line"><a name="l00765"></a><span class="lineno">  765</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="classParms.html#a8a374310cd30d52e940471d130fd9b00">writeContainer</a>(value, variable.begin(), variable.end());</div>
<div class="line"><a name="l00766"></a><span class="lineno">  766</span>&#160;}</div>
<div class="line"><a name="l00767"></a><span class="lineno">  767</span>&#160;</div>
<div class="line"><a name="l00768"></a><span class="lineno">  768</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00769"></a><span class="lineno"><a class="code" href="classParms.html#a0ecad7f930845a676706738628331e50">  769</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classParms.html#a1c64f37a3c1f45e82ca70bd0b70bf7e0">Parms::writeValue</a>(QString&amp; value, <span class="keyword">const</span> std::list&lt;T&gt;&amp; variable)</div>
<div class="line"><a name="l00770"></a><span class="lineno">  770</span>&#160;{</div>
<div class="line"><a name="l00771"></a><span class="lineno">  771</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="classParms.html#a8a374310cd30d52e940471d130fd9b00">writeContainer</a>(value, variable.begin(), variable.end());</div>
<div class="line"><a name="l00772"></a><span class="lineno">  772</span>&#160;}</div>
<div class="line"><a name="l00773"></a><span class="lineno">  773</span>&#160;</div>
<div class="line"><a name="l00774"></a><span class="lineno">  774</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00775"></a><span class="lineno"><a class="code" href="classParms.html#ab76dc07d0c30167638096e68decbb96d">  775</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classParms.html#a1c64f37a3c1f45e82ca70bd0b70bf7e0">Parms::writeValue</a>(QString&amp; value, <span class="keyword">const</span> std::set&lt;T&gt;&amp; variable)</div>
<div class="line"><a name="l00776"></a><span class="lineno">  776</span>&#160;{</div>
<div class="line"><a name="l00777"></a><span class="lineno">  777</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="classParms.html#a8a374310cd30d52e940471d130fd9b00">writeContainer</a>(value, variable.begin(), variable.end());</div>
<div class="line"><a name="l00778"></a><span class="lineno">  778</span>&#160;}</div>
<div class="line"><a name="l00779"></a><span class="lineno">  779</span>&#160;</div>
<div class="line"><a name="l00780"></a><span class="lineno">  780</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00781"></a><span class="lineno"><a class="code" href="classParms.html#a9f9de92bc4ee9295a7a384906d26e851">  781</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classParms.html#a1c64f37a3c1f45e82ca70bd0b70bf7e0">Parms::writeValue</a>(QString&amp; value, <span class="keyword">const</span> T&amp; variable)</div>
<div class="line"><a name="l00782"></a><span class="lineno">  782</span>&#160;{</div>
<div class="line"><a name="l00783"></a><span class="lineno">  783</span>&#160;    value = QString();</div>
<div class="line"><a name="l00784"></a><span class="lineno">  784</span>&#160;    QTextStream oss(&amp;value, QIODevice::WriteOnly);</div>
<div class="line"><a name="l00785"></a><span class="lineno">  785</span>&#160;    oss &lt;&lt; variable;</div>
<div class="line"><a name="l00786"></a><span class="lineno">  786</span>&#160;    <span class="keywordtype">bool</span> result = oss.status() == QTextStream::Ok;</div>
<div class="line"><a name="l00787"></a><span class="lineno">  787</span>&#160;    <span class="keywordflow">return</span> result;</div>
<div class="line"><a name="l00788"></a><span class="lineno">  788</span>&#160;}</div>
<div class="line"><a name="l00789"></a><span class="lineno">  789</span>&#160;</div>
<div class="line"><a name="l00790"></a><span class="lineno">  790</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00791"></a><span class="lineno"><a class="code" href="classParms.html#a3c50e04d38ec3ab6ef36d0d0cf314834">  791</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classParms.html#a3c50e04d38ec3ab6ef36d0d0cf314834">Parms::set</a>(QString section, QString key, <span class="keyword">const</span> T&amp; variable, <span class="keyword">const</span> QStringList&amp; comment)</div>
<div class="line"><a name="l00792"></a><span class="lineno">  792</span>&#160;{</div>
<div class="line"><a name="l00793"></a><span class="lineno">  793</span>&#160;    QString value;</div>
<div class="line"><a name="l00794"></a><span class="lineno">  794</span>&#160;    <span class="keywordflow">if</span>(!<a class="code" href="classParms.html#a1c64f37a3c1f45e82ca70bd0b70bf7e0">writeValue</a>(value, variable))</div>
<div class="line"><a name="l00795"></a><span class="lineno">  795</span>&#160;    {</div>
<div class="line"><a name="l00796"></a><span class="lineno">  796</span>&#160;        <span class="keywordflow">if</span>(<a class="code" href="classParms.html#a304288b4be84e292ebe1dad50aabe59f">VerboseLevel</a> &gt; 0)</div>
<div class="line"><a name="l00797"></a><span class="lineno">  797</span>&#160;            <a class="code" href="classParms.html#aa44d348824ac5264b1e5c256ec8187e0">err</a> &lt;&lt; <span class="stringliteral">&quot;Parms::set:Error writing value for key [&quot;</span> &lt;&lt; section &lt;&lt; <span class="stringliteral">&quot;]&quot;</span> &lt;&lt; key &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span> &lt;&lt; flush;</div>
<div class="line"><a name="l00798"></a><span class="lineno">  798</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00799"></a><span class="lineno">  799</span>&#160;    }</div>
<div class="line"><a name="l00800"></a><span class="lineno">  800</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="classParms.html#a41b9a8f363cedfeccd782cb165873dca">setValue</a>(section, key, <a class="code" href="structParms_1_1value__t.html">value_t</a>(value, comment));</div>
<div class="line"><a name="l00801"></a><span class="lineno">  801</span>&#160;}</div>
<div class="line"><a name="l00802"></a><span class="lineno">  802</span>&#160;</div>
<div class="line"><a name="l00803"></a><span class="lineno">  803</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00804"></a><span class="lineno"><a class="code" href="classParms.html#a8c04c71e01c3145028c23c480a842b19">  804</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classParms.html#a8c04c71e01c3145028c23c480a842b19">Parms::add</a>(QString section, QString key, <span class="keyword">const</span> T&amp; variable, <span class="keyword">const</span> QStringList&amp; comment)</div>
<div class="line"><a name="l00805"></a><span class="lineno">  805</span>&#160;{</div>
<div class="line"><a name="l00806"></a><span class="lineno">  806</span>&#160;    QString value;</div>
<div class="line"><a name="l00807"></a><span class="lineno">  807</span>&#160;    <span class="keywordflow">if</span>(!<a class="code" href="classParms.html#a1c64f37a3c1f45e82ca70bd0b70bf7e0">writeValue</a>(value, variable))</div>
<div class="line"><a name="l00808"></a><span class="lineno">  808</span>&#160;    {</div>
<div class="line"><a name="l00809"></a><span class="lineno">  809</span>&#160;        <span class="keywordflow">if</span>(<a class="code" href="classParms.html#a304288b4be84e292ebe1dad50aabe59f">VerboseLevel</a> &gt; 0)</div>
<div class="line"><a name="l00810"></a><span class="lineno">  810</span>&#160;            <a class="code" href="classParms.html#aa44d348824ac5264b1e5c256ec8187e0">err</a> &lt;&lt; <span class="stringliteral">&quot;Parms::set:Error writing value for key [&quot;</span> &lt;&lt; section &lt;&lt; <span class="stringliteral">&quot;]&quot;</span> &lt;&lt; key &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span> &lt;&lt; flush;</div>
<div class="line"><a name="l00811"></a><span class="lineno">  811</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00812"></a><span class="lineno">  812</span>&#160;    }</div>
<div class="line"><a name="l00813"></a><span class="lineno">  813</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="classParms.html#a9d945adcfdec06f9101784fa0444e9ed">addValue</a>(section, key, <a class="code" href="structParms_1_1value__t.html">value_t</a>(value, comment));</div>
<div class="line"><a name="l00814"></a><span class="lineno">  814</span>&#160;}</div>
<div class="line"><a name="l00815"></a><span class="lineno">  815</span>&#160;</div>
<div class="line"><a name="l00816"></a><span class="lineno">  816</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> Iterator&gt;</div>
<div class="line"><a name="l00817"></a><span class="lineno"><a class="code" href="classParms.html#a8a374310cd30d52e940471d130fd9b00">  817</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classParms.html#a8a374310cd30d52e940471d130fd9b00">Parms::writeContainer</a>(QString&amp; value, Iterator first, Iterator end)</div>
<div class="line"><a name="l00818"></a><span class="lineno">  818</span>&#160;{</div>
<div class="line"><a name="l00819"></a><span class="lineno">  819</span>&#160;    value = QString();</div>
<div class="line"><a name="l00820"></a><span class="lineno">  820</span>&#160;    QTextStream oss(&amp;value, QIODevice::WriteOnly);</div>
<div class="line"><a name="l00821"></a><span class="lineno">  821</span>&#160;    <span class="keywordflow">while</span>(first != end)</div>
<div class="line"><a name="l00822"></a><span class="lineno">  822</span>&#160;    {</div>
<div class="line"><a name="l00823"></a><span class="lineno">  823</span>&#160;        oss &lt;&lt; *first++;</div>
<div class="line"><a name="l00824"></a><span class="lineno">  824</span>&#160;        <span class="keywordflow">if</span>(first != end) oss &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;</div>
<div class="line"><a name="l00825"></a><span class="lineno">  825</span>&#160;    }</div>
<div class="line"><a name="l00826"></a><span class="lineno">  826</span>&#160;    <span class="keywordflow">return</span> oss.status() == QTextStream::Ok;</div>
<div class="line"><a name="l00827"></a><span class="lineno">  827</span>&#160;}</div>
<div class="line"><a name="l00828"></a><span class="lineno">  828</span>&#160;</div>
<div class="line"><a name="l00829"></a><span class="lineno">  829</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> Container&gt;</div>
<div class="line"><a name="l00830"></a><span class="lineno"><a class="code" href="classParms.html#a7647217ebd86af7aba31dc7fb7516223">  830</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classParms.html#a7647217ebd86af7aba31dc7fb7516223">Parms::setAll</a>( QString section, QString key, <span class="keyword">const</span> Container&amp; variable, <span class="keyword">const</span> QList&lt;QStringList&gt;&amp; comments)</div>
<div class="line"><a name="l00831"></a><span class="lineno">  831</span>&#160;{</div>
<div class="line"><a name="l00832"></a><span class="lineno">  832</span>&#160;    <a class="code" href="classParms.html#acc426969e9bf5e89a56dd9cbe77e2dfa">values_t</a> values;</div>
<div class="line"><a name="l00833"></a><span class="lineno">  833</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> Container::value_type T;</div>
<div class="line"><a name="l00834"></a><span class="lineno">  834</span>&#160;    <span class="keywordtype">int</span> i = 0;</div>
<div class="line"><a name="l00835"></a><span class="lineno">  835</span>&#160;    <span class="keywordflow">foreach</span>(<span class="keyword">const</span> T&amp; t, variable)</div>
<div class="line"><a name="l00836"></a><span class="lineno">  836</span>&#160;    {</div>
<div class="line"><a name="l00837"></a><span class="lineno">  837</span>&#160;        QString value;</div>
<div class="line"><a name="l00838"></a><span class="lineno">  838</span>&#160;        <span class="keywordflow">if</span>(!<a class="code" href="classParms.html#a1c64f37a3c1f45e82ca70bd0b70bf7e0">writeValue</a>(value, t))</div>
<div class="line"><a name="l00839"></a><span class="lineno">  839</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00840"></a><span class="lineno">  840</span>&#160;        <span class="keywordflow">if</span>(!comments.empty())</div>
<div class="line"><a name="l00841"></a><span class="lineno">  841</span>&#160;        {</div>
<div class="line"><a name="l00842"></a><span class="lineno">  842</span>&#160;            <span class="keywordflow">if</span>(comments.size() &lt;= i) <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00843"></a><span class="lineno">  843</span>&#160;            values &lt;&lt; <a class="code" href="structParms_1_1value__t.html">value_t</a>(value, comments[i]);</div>
<div class="line"><a name="l00844"></a><span class="lineno">  844</span>&#160;        }</div>
<div class="line"><a name="l00845"></a><span class="lineno">  845</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00846"></a><span class="lineno">  846</span>&#160;            values &lt;&lt; <a class="code" href="structParms_1_1value__t.html">value_t</a>(value, QStringList());</div>
<div class="line"><a name="l00847"></a><span class="lineno">  847</span>&#160;        ++i;</div>
<div class="line"><a name="l00848"></a><span class="lineno">  848</span>&#160;    }</div>
<div class="line"><a name="l00849"></a><span class="lineno">  849</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="classParms.html#a996412338909bf6412976e227051a6c1">setValues</a>(section, key, values);</div>
<div class="line"><a name="l00850"></a><span class="lineno">  850</span>&#160;}</div>
<div class="line"><a name="l00851"></a><span class="lineno">  851</span>&#160;</div>
<div class="line"><a name="l00852"></a><span class="lineno">  852</span>&#160;<span class="preprocessor">#endif</span></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Feb 26 2013 17:54:10 for morphorobotx by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1.2
</small></address>
</body>
</html>
